import React, { ReactElement } from 'react';
import { SVGProps } from 'react';

export type Sizes = 12 | 14 | 16 | 20 | 24 | 28 | 32 | 40;
export type IconProps = SVGProps<SVGSVGElement> & {
  component: ReactElement<any>;
  size?: Sizes;
  color?: string;
};

export const Icon: React.FC<IconProps> = ({ component, size = 24, color, ...props }) => {
  if (!component) {
    console.error(`No icon found`);
    return <div></div>;
  }
  const className = color ? `${color}` : '';
  return (
    <div className="flex grow-0 shrink-0">
      {React.cloneElement(component, {
        className,
        style: { fontSize: size },
        width: size,
        height: size,
        ...props,
      })}
    </div>
  );
};
